/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Authentication
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.util;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.DecimalFormat;
import java.util.Calendar;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import org.xml.sax.SAXException;

/**
 * Authentication クラス<br>
 * 認証および暗号キーの作成を行うクラス<br>
 * 認証キーの作成は、「ユーザID」+「LOID」+「現在時刻(HHMM)」+「起動元マネージャのサーバ名」
 * をMD5で暗号化し、認証および認証キーの作成を行う。<br>
 * authenticateメソッドでは、起動元マネージャの時刻とSCORMサーバの時刻がずれている事
 * が考えられる為、前後5分を許容する為、現在時刻、現在時刻 - 5分, 現在時刻 + 5分の順
 * で認証を行い、いずれかが成功した場合認証成功とする。<br>
 * また「現在時刻」は以下の論理で切り捨てを行い、認証キーの作成(及び認証)を行う。<br>
 * n0〜n4分 → n0分<br>
 * n5〜n9分 → n5分<br>
 */
public class Authentication {
	/** "9999"へフォーマットする為のDecimalFormat */
	private static DecimalFormat _9999Formatter = new DecimalFormat("0000");

	/** "99"へフォーマットする為のDecimalFormat */
	private static DecimalFormat _99Formatter = new DecimalFormat("00");

	/**
	 * 認証を行う。現在時刻、現在から5分前の時刻、現在から5分後の時刻の順で
	 * 認証を行い、いずれかが成功した場合はtrueを返却する。それ以外はfalse
	 * を返却する
	 *
	 * @param userID			ユーザIDを指定する<br>
	 * @param LOID				LOIDを指定する<br>
	 * @param authenticateKey	認証キーを指定する<br>
	 * @return	認証が成功した場合trueを失敗した場合はfalseを返却する<br>
	 */
	public static boolean authenticate(String userID, String LOID, String authenticateKey)
		throws NoSuchAlgorithmException, IOException, ParserConfigurationException, SAXException, TransformerException {

		if (SG.get("IgnoreAuthentication") != null) {
			return true;
		}

		String managerName = SG.get("ManagerName");

		Calendar calendar = Calendar.getInstance();

		boolean result;

		result = authenticateKey.equals(createKey(calendar, userID, LOID, managerName));
		if (result) {
			return true;
		}

		calendar.add(Calendar.MINUTE, -5);

		result = authenticateKey.equals(createKey(calendar, userID, LOID, managerName));
		if (result) {
			return true;
		}

		calendar.add(Calendar.MINUTE, 10);

		return authenticateKey.equals(createKey(calendar, userID, LOID, managerName));
	}

	/**
	 * 認証キーを作成する
	 *
	 * @param calendar	認証キーを作成する為の日付を指定する。
	 *					nullが指定された場合はシステム時刻から認証キーを作成する
	 * @param userID	ユーザIDを指定する
	 * @param LOID		LOIDを指定する
	 * @param secretKey	秘密キーを指定する
	 * @return	生成できた認証キーを返却する
	 */
	public static String createKey(Calendar calendar, String userID, String LOID, String secretKey)
		throws NoSuchAlgorithmException, UnsupportedEncodingException {

		if (calendar == null) {
			calendar = Calendar.getInstance();
		}

		StringBuffer seed = new StringBuffer();

		seed.append(userID);
		seed.append(LOID);
		seed.append(_9999Formatter.format(calendar.get(Calendar.YEAR)));
		seed.append(_99Formatter.format(calendar.get(Calendar.MONTH) + 1));
		seed.append(_99Formatter.format(calendar.get(Calendar.DATE)));
		seed.append(_99Formatter.format(calendar.get(Calendar.HOUR_OF_DAY)));
		seed.append(_99Formatter.format(calendar.get(Calendar.MINUTE) / 5 * 5));
		seed.append(secretKey);

		byte[] digest = MessageDigest.getInstance("MD5").digest(seed.toString().getBytes());

		StringBuffer result = new StringBuffer();

		for (int i = 0; i < digest.length; i++) {
			result.append(Integer.toHexString((digest[i] & 0xf0) >> 4));
			result.append(Integer.toHexString(digest[i] & 0x0f));
		}

		return result.toString();
	}
}
